/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */


package jpwr.beans;
import jpwr.rt.*;
import jpwr.jop.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.Timer;

public class JopTextField extends GeTextField
{
  public JopTextField()
  {
  }

  Color  lowColor = new Color( 175, 175, 175 );

  public void setLowColor( Color lowColor) {
    this.lowColor = lowColor;
  }
  public Color getLowColor() {
    return lowColor;
  }
  public void setAccess( int access) {
    dd.access = access;
  }
  public int getAccess() {
    return dd.access;
  }
  public void setPwrAttribute( String pwrAttribute) { 
    dd.data[0] = pwrAttribute;
  }
  public String getPwrAttribute() {
   return dd.data[0];
  }
  public void setPwrAttrColor( String pwrAttrColor) { 
    dd.data[2] = pwrAttrColor;
  }
  public String getPwrAttrColor() { 
    return dd.data[2];
  }
  public void setFormat( String format) {
    dd.data[1] = format;
  }
  public String getFormat() {
    return dd.data[1];
  }
  public void setMinimumValue( float minValue) {
    this.minValue = minValue;
  }
  public float getMinimumValue() {
    return this.minValue;
  }
  public void setMaximumValue( float maxValue) {
    this.maxValue = maxValue;
  }
  public float getMaximumValue() {
    return this.maxValue;
  }

  public void dynamicOpen() {
    String attrName = dd.getAttrName( dd.data[0]);
    if ( attrName.compareTo("") != 0) {
      ret = en.gdh.refObjectInfo( attrName);
      if ( ret.evenSts())
        System.out.println( "ObjectInfoError " + attrName);
      else {
        dd.attrFound[0] = true;
        dd.p[0] = ret.id;
        dd.subid[0] = ret.refid;
        dd.typeId[0] = ret.typeId;
        dd.setFormat( dd.data[1]);
      }
    }
    if ( dd.data[2] != null) {
      attrName = dd.getAttrName( dd.data[2]);
      if ( attrName.compareTo("") != 0) {
        ret = en.gdh.refObjectInfo( attrName);
        if ( ret.evenSts())
          System.out.println( "ObjectInfoError " + attrName);
        else {
          dd.attrFound[1] = true;
          dd.p[1] = ret.id;
          dd.subid[1] = ret.refid;
          dd.typeId[1] = ret.typeId;
          dd.inverted[1] = GeDyndata.getAttrInverted( dd.data[2]);
        }
      }
    }
    normalColor = getBackground();
    setBackground( normalColor);
  }
  public void dynamicClose() {
    if ( dd.attrFound[0])
      en.gdh.unrefObjectInfo( dd.subid[0]);
    if ( dd.attrFound[1])
      en.gdh.unrefObjectInfo( dd.subid[1]);
  }
  public void dynamicUpdate( boolean animationOnly) {
    if ( animationOnly)
      return;
    if ( !dd.attrFound[0] || focus)
      return;

    boolean repaintNow = false;
    if ( dd.typeId[0] == Pwr.eType_Float32) {
      float value0 = en.gdh.getObjectRefInfoFloat( dd.p[0]);
      if ( value0 != dd.oldValueF[0]) {
        sb = dd.format( value0, sb);
        setText(new String(sb));
        repaintNow = true;
        dd.oldValueF[0] = value0;
      }
    }
    else if ( dd.typeId[0] == Pwr.eType_Int32) {
      int value0 = en.gdh.getObjectRefInfoInt( dd.p[0]);
      if ( value0 != dd.oldValueI) {
        sb = dd.format( value0, sb);
        setText(new String(sb));
        repaintNow = true;
        dd.oldValueI = value0;
      }
    }
    else if ( dd.typeId[0] == Pwr.eType_String) {
      String value0 = en.gdh.getObjectRefInfoString( dd.p[0], dd.typeId[0]);
      if ( value0.compareTo( dd.oldValueS) != 0) {
        sb = dd.format( value0, sb);
        setText(new String(sb));
        repaintNow = true;
        dd.oldValueS = value0;
      }
    }
    if ( dd.attrFound[1]) {
      boolean value1 = en.gdh.getObjectRefInfoBoolean( dd.p[1]);
      if ( value1 != dd.oldValueB[1] || dd.firstScan) {
        if ( (!dd.inverted[1] && value1) || (dd.inverted[1] && !value1))
          setBackground( normalColor);
        else
          setBackground( lowColor);
        repaintNow = true;
        dd.oldValueB[1] = value1;
      }
    }
    if ( repaintNow)
//      repaintForeground();
    if ( dd.firstScan)
      dd.firstScan = false;

//    if ( valueAttr < alarmLimitLow || valueAttr > alarmLimitHigh)
//      setBackground( alarmColor);
//    else
//      setBackground( normalColor);
  }

}
