/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.jop;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import jpwr.rt.*;

/** 
   Event statistics.
   The HistStatistics class is a JPanel containing two JTables showing 
   statistics derived from the MhData supplied in the constructor. The tables
   get their contents from a HistStatModel1 and an HistStatModel2. The tables support
   the use of JopMethodsMenu.
*/

public class HistStatistics extends JPanel{
    
    // The session is needed for the use of JopMethodsMenu
    private JopSession session;
    private JTable fTable, eTable;
    private HistStatModel1 fModel;
    private HistStatModel2 eModel;
    
    JScrollPane fScroll, eScroll;
    int lang;

    String[] names = {JopLang.transl("Most frequent alarms"),
		      JopLang.transl("Longest duration")};
    
    public HistStatistics(MhData m, JopSession s){
    //Setup and layout. (The only method of this class..)
    session = s;
    this.setLayout(new GridLayout(2,1));
    JPanel upper = new JPanel();
    upper.setLayout(new BorderLayout());
    fModel=new HistStatModel1(m,lang);
    fTable = new JTable(fModel);
    fScroll= new JScrollPane(fTable );
    fTable.getColumnModel().getColumn(0).setPreferredWidth(420);
    fTable.getColumnModel().getColumn(1).setPreferredWidth(70);
    //Mouse listener for fTable JopMethodMenu support.
    fTable.addMouseListener(new MouseAdapter() {
        public void mouseReleased(MouseEvent e) {
            if ( e.isPopupTrigger()) {
            int row=fTable.rowAtPoint(e.getPoint());
            MhrEvent event = (MhrEvent) fModel.result.get(row);
            String trace_object= event.eventName;
            new JopMethodsMenu( session, 
                        trace_object, 
                        JopUtility.TRACE,(Component) fTable, 
                        e.getX(), e.getY());
            return;
            }
        }
        public void mousePressed(MouseEvent e) {
           if ( e.isPopupTrigger()) {
            int row=fTable.rowAtPoint(e.getPoint());
            MhrEvent event = (MhrEvent) fModel.result.get(row);
            String trace_object= event.eventName;
            new JopMethodsMenu( session, 
                        trace_object, 
                        JopUtility.TRACE,(Component) fTable, 
                        e.getX(), e.getY());
            return;
            
            }
        }
        public void mouseClicked(MouseEvent e) {
        }
        });
    upper.add(fScroll,BorderLayout.CENTER);
    upper.add(new JLabel(names[0]), BorderLayout.NORTH);
    upper.add(new JLabel("\n\n") , BorderLayout.SOUTH);
    JPanel lower = new JPanel();
    lower.setLayout(new BorderLayout());
        eModel=new HistStatModel2(m);
        eTable = new JTable(eModel);
        eScroll= new JScrollPane(eTable );
    eTable.getColumnModel().getColumn(0).setPreferredWidth(420);
    eTable.getColumnModel().getColumn(1).setPreferredWidth(70);
    //Mouse listener for eTable JopMethodMenu support.
    eTable.addMouseListener(new MouseAdapter() {
        public void mouseReleased(MouseEvent e) {
            if ( e.isPopupTrigger()) {
            int row=eTable.rowAtPoint(e.getPoint());
            MhrEvent event = (MhrEvent) eModel.result.get(row);
            String trace_object= event.eventName;
            new JopMethodsMenu( session, 
                        trace_object, 
                        JopUtility.TRACE,(Component) eTable, 
                        e.getX(), e.getY());
            return;
            }
        }
        public void mousePressed(MouseEvent e) {
           if ( e.isPopupTrigger()) {
            int row=eTable.rowAtPoint(e.getPoint());
            MhrEvent event = (MhrEvent) eModel.result.get(row);
            String trace_object= event.eventName;
            new JopMethodsMenu( session, 
                        trace_object, 
                        JopUtility.TRACE,(Component) eTable, 
                        e.getX(), e.getY());
            return;
            
            }
        }
        public void mouseClicked(MouseEvent e) {
        }
        });
    lower.add(eScroll,BorderLayout.CENTER);
    lower.add(new JLabel(names[1]), BorderLayout.NORTH);
    this.setPreferredSize(new Dimension(600, 500));
        this.add(upper); 
        this.add(lower);
               
    }
}
