/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.jop;
import jpwr.rt.*;

public interface JopSessionIfc {
  public void setSession( Object session);
  public void setRoot( Object root);
  public Object getRoot();
  public void setEngine( JopEngine engine);
  public String getLang();
  public void setLang( String lang);
  public JopEngine getEngine();
  public void setNavigator( Object navigator);
  public void setAlarmList( Object alarmList);
  public void addUtility( Object utility);
  public void removeUtility( Object utility);
  public void openNavigator( PwrtObjid oid);
  public void openAlarmList();
  public void openEventLog();
  public void openLogin();
  public void openLanguage();
  public void openGraphFrame( String name, String instance, boolean scrollbar, boolean classGraph);
  public void openFlowFrame( PwrtObjid oid, String center);
  public void openCrrFrame( String name);
  public int executeCommand( String command);
  public boolean isApplet();
  public boolean isApplication();
  public boolean isOpWindowApplet();
  public void openSearch(String object);
  public void setOpWindowLabelText( String text );
  public void setOpWindowLanguage( int language );
  public void openTrend( String[] trendList);
  public void openFast( String fastObject);
  public Object getUtility( int type, PwrtObjid objid, String name);
}
