/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.jop;
import java.util.*;
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.net.URL;
import jpwr.rt.*;

/**
 *  Runtime navigator started as an applet.
 *
 *  @author     JN
 */
public class JopXttApplet extends JopApplet
{
  boolean sim = false;
  XttTree xttTree;

  /**
   *  Sets the size attribute of the JopXttApplet object
   *
   *  @param  width   The new size value
   *  @param  height  The new size value
   */
  public void setSize(int width, int height)
  {
    Logg.logg("JopXttApplet: setSize()", 1);

    super.setSize(width, height);

    validate();
  }


  public String GetAppletInfo()
  {
    return "Applet information";
  }


  /**
   *  Gets the parameterInfo attribute of the JopXttApplet object
   *
   *  @return    The parameterInfo value
   */
  public String[][] getParameterInfo()
  {
    return null;
  }
  public void destroy()
  {
    if(!sim)
    {
      super.destroy();
    }
  }

  public void init()
  {
    super.init();
    setSize(new Dimension(370, 570));
    URL url = this.getCodeBase();
    Logg.loggTo = Logg.TO_SCREEN;
    Logg.loggPrio = 0;
    Logg.logg("JopXttApplet: Before XttTree-creation", 6);
    this.xttTree = new XttTree( session, url, this);
    this.getContentPane().add(this.xttTree);
    this.xttTree.createUserInputs();
    Logg.logg("JopXttApplet: XttTree-created", 6);
  }

  /**  Description of the Method */
  public void start()
  {
    Logg.logg("JopXttApplet: start() called", 6);
    this.xttTree.tree.requestFocus();
  }


  /**  Description of the Method */
  public void stop()
  {
  }
}

