/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.jop;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.net.URL;
import jpwr.rt.*;

/**
 *  Runtime navigator started as a frame.
 *
 *  @author     JN
 */
public class JopXttFrame extends JFrame implements GdhApplIfc
{
  JopSession session;
  JopEngine engine;
  XttTree xttTree;
  Object root;
  /**  Description of the Method */
  public JopXttFrame()
  {
    engine = new JopEngine( 1000, this);
    session = new JopSession( engine, (Object)this);
    root = (Object) this;
    init((PwrtObjid)null);
    setTitle(JopLang.transl("Navigator"));
  }
  public JopXttFrame( JopSession session, PwrtObjid oid )
  {
    this.session = session;
    engine = session.getEngine();
    root = session.getRoot();
    init(oid);
    setTitle(JopLang.transl("Navigator"));
  }    
  public void init(PwrtObjid oid)
  {
    setSize(new Dimension(400, 700));
    URL url = null;
    Logg.loggTo = Logg.TO_SCREEN;
    Logg.loggPrio = 0;
    Logg.logg("JopXttApplet: Before XttTree-created", 6);
    this.xttTree = new XttTree(this.session, url, this);
    this.getContentPane().add(this.xttTree);
    this.xttTree.createUserInputs();
    Logg.logg("JopXttApplet: XttTree created", 6);

    class WindowCatcher extends WindowAdapter
    {
        public void windowClosing( WindowEvent e )
	{
	  setVisible( false);
        }
    }
    addWindowListener( new WindowCatcher());
    setDefaultCloseOperation( DO_NOTHING_ON_CLOSE);
    if(oid != null)
    {
      this.xttTree.find(oid);
    }
  }

  // GdhApplIfc function
  public String getPwrHost() {
    return (String)null;
  }

  public static void main(String[] args)
  {
    boolean debug = false;
    for(int i = 0; i < args.length; i++)
    {
      if(args[i].equals("-d") || args[i].equals("-D"))
      {
        debug = true;
      }
    }
    JopXttFrame frame = new JopXttFrame();
    frame.pack();
    frame.setVisible(true);
  }

}

