/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.jop;
import java.util.Vector;
import javax.swing.tree.DefaultMutableTreeNode;
import jpwr.rt.*;
/**
 *  Xtt object with ref.
 *
 *  @author     JN
 */
public class XttRefObj extends DynamicObj implements JopDynamic
{
  public XttObjAttr objAttribute = null;
  //static JopEngine en;
  int cid;
//  String showableClassName = null;
  String fullname;
  int index;
  
  static boolean initdone = false;
  static String[] AttributeNameArray = {"ActualValue", 
                                        "ActualValue", 
					/*"ActualValue",*/
                                        "ActualValue", 
					"ActualValue", 
					"ActualValue", 
					"ActualValue", 
					
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					"Status", 
					
					"Action", 
					"Action", 
					
					"in", 
					
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					"ActVal", 
					
					"MaxVal",
					 
					"High", 
					
					"Low", 
					
					"OutVal", 
					"OutVal"};
  static int[] TypeClassId =           {Pwrb.cClass_Dv, 
                                        Pwrb.cClass_Av,  
					/*Pwrb.cClass_Sv,*/
					Pwrb.cClass_Di, 
					Pwrb.cClass_Do, 
					Pwrb.cClass_Ai,
                                        Pwrb.cClass_Ao, 
					
					Pwrb.cClass_and,
					Pwrb.cClass_or, 
					Pwrb.cClass_xor, 
					Pwrb.cClass_edge,
					Pwrb.cClass_sr_s,
					Pwrb.cClass_sr_r,
					Pwrb.cClass_pulse,
					Pwrb.cClass_wait,
					Pwrb.cClass_timer,
					Pwrb.cClass_inv,
					Pwrb.cClass_waith,
					Pwrb.cClass_darithm,
					
					Pwrb.cClass_DSup,
					Pwrb.cClass_ASup,
					
					Pwrb.cClass_csub, 
					
					Pwrb.cClass_sum, 
					Pwrb.cClass_limit, 
					Pwrb.cClass_select, 
					Pwrb.cClass_ramp, 
					Pwrb.cClass_filter, 
					Pwrb.cClass_speed, 
					Pwrb.cClass_curve, 
					Pwrb.cClass_adelay, 
					Pwrb.cClass_aarithm, 
					Pwrb.cClass_timint, 
					
					Pwrb.cClass_maxmin, 
					
					Pwrb.cClass_comph, 
					
					Pwrb.cClass_compl, 
					
					Pwrb.cClass_pid, 
					Pwrb.cClass_mode};
  static String[] TypeNameArray =      {"Dv", 
                                        "Av",  
					/*"Sv",*/
					"Di", 
					"Do", 
					"Ai", 
					"Ao", 
					
					"And",
					"Or",
					"Xor",
					"Edge", 
					"SR_S",
					"SR_R",
					"Pulse",
					"Wait",
					"Timer",
					"Inv",
					"Waith",
					"DArithm", 
					
					"DSup",
					"ASup",
					
					"CSub", 
					
					"Sum", 
					"Limit", 
					"Select", 
					"Ramp", 
					"Filter", 
					"Speed", 
					"Curve", 
					"ADelay", 
					"AArithm",
					"Timint", 
					
					"MaxMin", 
					
					"Comph", 
					
					"Compl", 
					
					"PID", 
					"Mode"};
  static CdhrObjAttr[] AttrObj = new CdhrObjAttr[TypeNameArray.length];
  static boolean firstTime = true;


  /**
   *  Constructor for the XttRefObj object
   */
  public XttRefObj(String fullname, JopEngine en, int cid,  /*String showableClassName,*/DefaultMutableTreeNode treeNode, int index)
  {
    this.index = index;
    this.fullname = fullname;
    XttRefObj.en = en;
    this.cid = cid;
//    this.showableClassName = showableClassName;
    if(index < 0)
    {
      Logg.logg("Error at debug attempt", 0);
      return;
    }
    CdhrObjAttr oa = AttrObj[index];
    Logg.logg("XttRefObj konstruktor", 6);
    if(oa != null)
    {
      objAttribute = new XttObjAttr(oa);
      objAttribute.treeNode = treeNode;
      objAttribute.showName = false;
      en.add(this);
    }
    else
    {
      Logg.logg("Can not debug " + fullname + " cid: " + cid + " on index " + index, 0);
    }
  }


  /**
   *  Gets the pwrtRefId attribute of the XttRefObj object
   *
   *  @return    The pwrtRefId value
   */
  public PwrtRefId getPwrtRefId()
  {
    if(objAttribute != null && objAttribute.refObj != null)
    {
      return objAttribute.refObj.refid;
    }
    return null;
  }


  /**
   *  Gets the xttObjAttr attribute of the XttRefObj object
   *
   *  @return    The xttObjAttr value
   */
  public XttObjAttr getXttObjAttr()
  {

    Logg.logg("XttRefObj: getXttObjAttr", 6);
    String s = null;
    String suffix;
    suffix = this.setTypeIdString(objAttribute.type, objAttribute.size);
    s = this.fullname + "." + objAttribute.name + suffix;
    objAttribute.fullName = s;
    Logg.logg("XttRefObj:  Name " + s, 6);
    return objAttribute;
  }


  public Object dynamicGetRoot() 
  {
    return null;
  }

  public void dynamicClose()
  {
  }



  public void dynamicOpen()
  {
  }


  public void dynamicUpdate(boolean animationOnly)
  {
    if(animationOnly)
    {
      Logg.logg("XttRefObj: animationOnly", 6);
      return;
    }
    this.setObjectAttributeValue(objAttribute);
  }


  public void localDynamicClose()
  {
  }


  public String toString()
  {
    if(objAttribute != null)
    {
      return objAttribute.toString();
    }
    else
    {
      return " ";
    }
  }


  /**
   *  Gets the wantedClassAttribute attribute of the XttRefObj class
   *
   *  @param  index  Description of the Parameter
   *  @return        The wantedClassAttribute value
   */
  public static CdhrObjAttr getWantedClassAttribute(int index)
  {
    PwrtObjid objid_obj = new PwrtObjid(0, 0);
    Vector attr_vec = en.gdh.getAllClassAttributes(TypeClassId[index], objid_obj);
    if(attr_vec != null)
    {
      for(int i = 0; i < attr_vec.size(); i++)
      {
        CdhrObjAttr attr = (CdhrObjAttr)attr_vec.get(i);
        if(attr.name.compareTo(AttributeNameArray[index]) == 0)
        {
          return attr;
        }
      }
    }
    return null;
  }


  public static int checkTypeName(String s)
  {
    for(int i = 0; i < XttRefObj.TypeNameArray.length; i++)
    {
      if(s.compareTo(XttRefObj.TypeNameArray[i]) == 0)
      {
        return i;
      }
    }
    return -1;
  }

  public static void init(JopEngine en)
  {
    if(XttRefObj.initdone)
      return;
    XttRefObj.en = en;
    for(int i = 0; i < TypeClassId.length; i++)
    {
      AttrObj[i] = XttRefObj.getWantedClassAttribute(i);
    }
    XttRefObj.initdone = true;
  }

}


