/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */


package jpwr.jopg;
import jpwr.rt.*;

public interface GraphIfc {
    public static final int eDatabase_Gdh 	= 0;
    public static final int eDatabase_User	= 1;
    public static final int eDatabase_Local 	= 2;
    public static final int eDatabase_Ccm 	= 3;

    public static final int eType_Bit 		= (1 << 15) + 1;

    public DynParsedAttrName parseAttrName( String name);    
    public Gdh getGdh();
    public GraphLocalDb getLdb();
    public GrowCtx getCtx();
    public GrowCmn getCmn();
    public void cmnPop( GrowCmn cmn);
    public void cmnPush();
    public int command(String cmd);
    public int script(String script);
    public void closeGraph();
    public void openConfirmDialog(Object dyn, String text, Object object);
    public void openValueInputDialog(Object dyn, String text, Object object);
    public void openPopupMenu(String object, double x, double y);
    public String get_reference_name(String name);
    public Object getCurrentSlider();
    public void setCurrentSlider(GrowSlider currentSlider);
    public boolean isAuthorized(int access);
    public void setScanTime(double scan_time);
    public void setFastScanTime(double fast_scan_time);
    public void setAnimationScanTime(double animation_scan_time);
    public double getScanTime();
    public double getFastScanTime();
    public double getAnimationScanTime();
    public String getCommand(String cmd);
    public void setClickActive(int active);
}
