/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.rt;

/**
   Interface to system messages.
*/
public class Errh {
  public static final int eAnix_webmon 		= 14;
  public static final int eAnix_webmonmh       	= 15;

  public static final int PWR__SRVSTARTUP       = 134512720;
  public static final int PWR__SRUN             = 134512731;
  public static final int PWR__SRVRESTART       = 134512736;
  public static final int PWR__SRVTERM          = 134512748;

  static {
    System.loadLibrary("jpwr_rt_gdh");
  }
  
  private static boolean initDone = false;

  public Errh( String programName, int anix) {
    if ( !initDone) {
      init( programName, anix);
      initDone = true;
    }
  }
  
  private native int init( String programName, int anix);
  /** Set process status. */
  public native void setStatus( int sts);
  /** Write a fatal system message. */
  public native void fatal( String msg);
  /** Write an error system message. */
  public native void error( String msg);
  /** Write a warning system message. */
  public native void warning( String msg);
  /** Write an info system message. */
  public native void info( String msg);
  /** Write a success system message. */
  public native void success( String msg);
}



