/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

package jpwr.rt;
import java.io.Serializable;

/**
   Return class for functions returning attribute characteristics.
   Contains a return status and attribute characteristics.
*/
public class GdhrGetAttributeChar implements Serializable
{
  public int typeId;
  public int size;
  public int offset;
  public int elements;
  public int sts;
  
  public GdhrGetAttributeChar( int typeId, int size, int offset,
					  int elements, int sts) {
    this.typeId = typeId;
    this.size = size;
    this.offset = offset;
    this.elements = elements;
    this.sts = sts;
  }
  /** Check if status is even. */
  public boolean evenSts() { return (sts % 2 == 0);}
  /** Check if status is odd. */
  public boolean oddSts() { return (sts % 2 == 1);}
  /** Get the status. */
  public int getSts() { return sts;}
}
