/* 
 * Proview   Open Source Process Control.
 * Copyright (C) 2005-2016 SSAB EMEA AB.
 *
 * This file is part of Proview.
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation, either version 2 of 
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with Proview. If not, see <http://www.gnu.org/licenses/>
 *
 * Linking Proview statically or dynamically with other modules is
 * making a combined work based on Proview. Thus, the terms and 
 * conditions of the GNU General Public License cover the whole 
 * combination.
 *
 * In addition, as a special exception, the copyright holders of
 * Proview give you permission to, from the build function in the
 * Proview Configurator, combine Proview with modules generated by the
 * Proview PLC Editor to a PLC program, regardless of the license
 * terms of these modules. You may copy and distribute the resulting
 * combined work under the terms of your choice, provided that every 
 * copy of the combined work is accompanied by a complete copy of 
 * the source code of Proview (the version used to produce the 
 * combined work), being distributed under the terms of the GNU 
 * General Public License plus this exception.
 */

  package jpwr.rt;
  import java.io.Serializable;
  import java.util.*;

  /**
   * Element of subscription data.
   * <p>
   * Object that is stored in the static vector in GdhServer handling all subscriptions.
   *
   * @author     JN
   */

  public class SubElement
  {
    public int[] reffedByThread;
    public BitSet reffedByThreadBitSet;
    Sub sub = new Sub(" ", new PwrtRefId(0, 0), 0, 0, 0,0,0);


    public SubElement(int maxConnections, int threadNumber)
    {
      reffedByThread = new int[maxConnections];
      reffedByThreadBitSet = new BitSet(maxConnections);
      reffedByThreadBitSet.set(threadNumber);
      for(int i = 0; i < reffedByThread.length; i++)
      {
        reffedByThread[i] = 0;
      }
    }
    public SubElement(String attrName)
    {
      this.sub.attrName = attrName;
    }

    public Sub getSub()
    {
      return sub;
    }
    public void setSub(GdhrRefObjectInfo obj, int subscriptionsIndex, String attrName)
    {
      this.sub.attrName = attrName;
      this.sub.refid = obj.refid;
      this.sub.id = obj.id;
      this.sub.sts = obj.sts;
      this.sub.typeId = obj.typeId;
      this.sub.size = obj.size;
      this.sub.elements = obj.elements;
      this.sub.subscriptionsIndex = subscriptionsIndex;

    }
    public boolean equals(Object o)
    {
      return (this.sub.attrName.equalsIgnoreCase(((SubElement)o).sub.attrName) && (((SubElement)o).sub.sts != 0));
    }
  }

